#include <signal.h>
#include <cstdio>
#include <unistd.h>
#include <cstdlib>
#include <iostream>
#include <cstring>
#include <cerrno>
/* Timers and signal handlers */
/* LG, Mars 2020, pour LIFASR5, version sigaction */


int varglob = 25;
int *padr;

// Les deux fonctions pour les traitements des erreurs, cf tp minishell
void msg_error(const std::string &msg) {
  std::cerr << "## ERREUR : " << std::flush;
  if(msg != "") std::cerr << msg << ", " << std::flush;
  std::cerr << strerror(errno) << std::endl << std::flush;
}
void exit_error(const std::string &msg) {
  msg_error(msg);
  exit(EXIT_FAILURE);
}


// Fonction à appeler régulièrement
void top(int s) { // le numéro du signal n'est pas utilisé.
  static int nb = 0; // variable statique, cf par exemple https://www.ljll.math.upmc.fr/courscpp/Sections/Sect05-E3.html
  if ((++nb)%5==0) {
    std::cout << "+";
  } else {
    std::cout << ".";
  }
  // on force l'affichage immédiat
  std::cout.flush();
}

int main(int argc, char* argv[]) {
  struct sigaction sa;
  //TODO 1: gestionnaire de signal alarm = SIGALRM, qui doit lancer top.
  while (1) {
    pause(); // lire le manuel de pause et expliquer!
    //TODO 2: lancer une alarme 
  }
  return 0;
}
