#include <unistd.h>

int write_int(int fd, int x) {
  int nbwr, nbrem = sizeof(int);
  // Un cast de int* vers char* est nécessaire :
  char *p = reinterpret_cast<char*>(&x);
  // On peut aussi utiliser : char *p = (char*)&x

  while(nbrem > 0) {
    nbwr = write(fd, p, nbrem);
    if(nbwr == -1) return -1;
    p += nbwr;
    nbrem -= nbwr;
  }
  return 1;
}

int read_int(int fd, int &x) {
  int nbrd, nbrem = sizeof(int);
  // Un cast de int* vers char* est nécessaire :
  char *p = reinterpret_cast<char*>(&x);
  // On peut aussi utiliser : char *p = (char*)&x

  while(nbrem > 0) {
    nbrd = read(fd, p, nbrem);
    if(nbrd == -1 || nbrd == 0) return nbrd;
    p += nbrd;
    nbrem -= nbrd;
  }
  return 1;
}
